diff -r 873d6d76778e trytond/modules/calendar_todo/todo.py
--- a/trytond/modules/calendar_todo/todo.py	Wed Sep 19 22:19:45 2012 +0200
+++ b/trytond/modules/calendar_todo/todo.py	Mon Sep 24 20:36:40 2012 +0200
@@ -13,6 +13,9 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['Todo', 'TodoCategory', 'TodoRDate', 'TodoRRule', 'TodoExDate',
+    'TodoExRule', 'TodoAttendee', 'TodoAlarm']
+
 tzlocal = dateutil.tz.tzlocal()
 tzutc = dateutil.tz.tzutc()
 
@@ -21,10 +24,8 @@
 
 class Todo(ModelSQL, ModelView):
     "Todo"
-    _description = __doc__
-    _name = 'calendar.todo'
+    __name__ = 'calendar.todo'
     _rec_name = 'uuid'
-
     calendar = fields.Many2One('calendar.calendar', 'Calendar',
             required=True, select=True, ondelete="CASCADE")
     alarms = fields.One2Many('calendar.todo.alarm', 'todo', 'Alarms')
@@ -110,102 +111,106 @@
         'Write Users'), 'get_calendar_field', searcher='search_calendar_field')
     vtodo = fields.Binary('vtodo')
 
-    def __init__(self):
-        super(Todo, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(Todo, cls).__setup__()
+        cls._sql_constraints = [
             #XXX should be unique across all componenets
             ('uuid_recurrence_uniq', 'UNIQUE(uuid, calendar, recurrence)',
                 'UUID and recurrence must be unique in a calendar!'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_recurrence', 'invalid_recurrence'),
-        ]
-        self._error_messages.update({
-            'invalid_recurrence': 'Recurrence can not be recurrent!',
-        })
+            ]
+        cls._error_messages.update({
+                'invalid_recurrence': 'Recurrence can not be recurrent!',
+                })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
+        pool = Pool()
         # Migrate from 1.4: remove classification_public
-        model_data_obj = Pool().get('ir.model.data')
-        rule_obj = Pool().get('ir.rule')
+        ModelData = pool.get('ir.model.data')
+        Rule = pool.get('ir.rule')
         with Transaction().set_user(0):
-            model_data_ids = model_data_obj.search([
+            models_data = ModelData.search([
                 ('fs_id', '=', 'rule_group_read_todo_line3'),
                 ('module', '=', module_name),
                 ('inherit', '=', None),
                 ], limit=1)
-            if model_data_ids:
-                model_data = model_data_obj.browse(model_data_ids[0])
-                rule_obj.delete(model_data.db_id)
-        return super(Todo, self).init(module_name)
+            if models_data:
+                model_data, = models_data
+                Rule.delete([Rule(model_data.db_id)])
+        super(Todo, cls).__register__(module_name)
 
-    def default_uuid(self):
+    @staticmethod
+    def default_uuid():
         return str(uuid.uuid4())
 
-    def default_sequence(self):
+    @staticmethod
+    def default_sequence():
         return 0
 
-    def default_classification(self):
+    @staticmethod
+    def default_classification():
         return 'public'
 
-    def default_timezone(self):
-        user_obj = Pool().get('res.user')
-        user = user_obj.browse(Transaction().user)
+    @staticmethod
+    def default_timezone():
+        User = Pool().get('res.user')
+        user = User(Transaction().user)
         return user.timezone
 
-    def default_percent_complete(self):
+    @staticmethod
+    def default_percent_complete():
         return 0
 
-    def on_change_status(self, vals):
+    def on_change_status(self):
         res = {}
-        if 'status' not in vals:
+        if not getattr(self, 'status', None):
             return res
-        if vals['status'] == 'completed':
+        if self.status == 'completed':
             res['percent_complete'] = 100
-            if not vals.get('completed'):
+            if not getattr(self, 'completed', None):
                 res['completed'] = datetime.datetime.now()
 
         return res
 
-    def timezones(self):
+    @staticmethod
+    def timezones():
         return [(x, x) for x in pytz.common_timezones] + [('', '')]
 
-    def get_calendar_field(self, ids, name):
-        assert name in ('calendar_owner', 'calendar_read_users',
-                'calendar_write_users'), 'Invalid name'
-        res = {}
-        for todo in self.browse(ids):
-            name = name[9:]
-            if name in ('read_users', 'write_users'):
-                res[todo.id] = [x.id for x in todo.calendar[name]]
-            else:
-                res[todo.id] = todo.calendar[name].id
-        return res
+    def get_calendar_field(self, name):
+        name = name[9:]
+        if name in ('read_users', 'write_users'):
+            return [x.id for x in getattr(self.calendar, name)]
+        else:
+            return getattr(self.calendar, name).id
 
     def search_calendar_field(self, name, clause):
         return [('calendar.' + name[9:],) + tuple(clause[1:])]
 
-    def check_recurrence(self, ids):
+    def check_recurrence(self):
         '''
         Check the recurrence is not recurrent.
         '''
-        for todo in self.browse(ids):
-            if not todo.parent:
-                continue
-            if todo.rdates \
-                    or todo.rrules \
-                    or todo.exdates \
-                    or todo.exrules \
-                    or todo.occurences:
-                return False
+        if not self.parent:
+            return True
+        if (self.rdates
+                or self.rrules
+                or self.exdates
+                or self.exrules
+                or self.occurences):
+            return False
         return True
 
-    def create(self, values):
-        calendar_obj = Pool().get('calendar.calendar')
-        collection_obj = Pool().get('webdav.collection')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Calendar = pool.get('calendar.calendar')
+        Collection = pool.get('webdav.collection')
 
-        res = super(Todo, self).create(values)
-        todo = self.browse(res)
+        todo = super(Todo, cls).create(values)
         if (todo.calendar.owner
                 and (todo.organizer == todo.calendar.owner.email
                     or (todo.parent
@@ -221,73 +226,69 @@
                         and x.email != todo.parent.organizer]
             if attendee_emails:
                 with Transaction().set_user(0):
-                    calendar_ids = calendar_obj.search([
+                    calendars = Calendar.search([
                         ('owner.email', 'in', attendee_emails),
                         ])
                     if not todo.recurrence:
-                        for calendar_id in calendar_ids:
-                            new_id = self.copy(todo.id, default={
-                                'calendar': calendar_id,
+                        for calendar in calendars:
+                            new_todo = cls.copy([todo], default={
+                                'calendar': calendar.id,
                                 'occurences': None,
                                 })
                             for occurence in todo.occurences:
-                                self.copy(occurence.id, default={
-                                    'calendar': calendar_id,
-                                    'parent': new_id,
+                                cls.copy([occurence], default={
+                                    'calendar': calendar.id,
+                                    'parent': new_todo.id,
                                     })
                     else:
-                        parent_ids = self.search([
+                        parents = cls.search([
                             ('uuid', '=', todo.uuid),
                             ('calendar.owner.email', 'in', attendee_emails),
                             ('id', '!=', todo.id),
                             ('recurrence', '=', None),
                             ])
-                        for parent in self.browse(parent_ids):
-                            self.copy(todo.id, default={
+                        for parent in parents:
+                            cls.copy([todo], default={
                                 'calendar': parent.calendar.id,
                                 'parent': parent.id,
                                 })
         # Restart the cache for todo
-        collection_obj.todo.reset()
-        return res
+        Collection._todo_cache.clear()
+        return todo
 
-    def _todo2update(self, todo):
-        pool = Pool()
-        rdate_obj = pool.get('calendar.todo.rdate')
-        exdate_obj = pool.get('calendar.todo.exdate')
-        rrule_obj = pool.get('calendar.todo.rrule')
-        exrule_obj = pool.get('calendar.todo.exrule')
-
+    def _todo2update(self):
         res = {}
-        res['summary'] = todo.summary
-        res['description'] = todo.description
-        res['dtstart'] = todo.dtstart
-        res['percent_complete'] = todo.percent_complete
-        res['completed'] = todo.completed
-        res['location'] = todo.location.id
-        res['status'] = todo.status
-        res['organizer'] = todo.organizer
+        res['summary'] = self.summary
+        res['description'] = self.description
+        res['dtstart'] = self.dtstart
+        res['percent_complete'] = self.percent_complete
+        res['completed'] = self.completed
+        res['location'] = self.location.id
+        res['status'] = self.status
+        res['organizer'] = self.organizer
         res['rdates'] = [('delete_all',)]
-        for rdate in todo.rdates:
-            vals = rdate_obj._date2update(rdate)
+        for rdate in self.rdates:
+            vals = rdate._date2update()
             res['rdates'].append(('create', vals))
         res['exdates'] = [('delete_all',)]
-        for exdate in todo.exdates:
-            vals = exdate_obj._date2update(exdate)
+        for exdate in self.exdates:
+            vals = exdate._date2update()
             res['exdates'].append(('create', vals))
         res['rrules'] = [('delete_all',)]
-        for rrule in todo.rrules:
-            vals = rrule_obj._rule2update(rrule)
+        for rrule in self.rrules:
+            vals = rrule._rule2update()
             res['rrules'].append(('create', vals))
         res['exrules'] = [('delete_all',)]
-        for exrule in todo.exrules:
-            vals = exrule_obj._rule2update(exrule)
+        for exrule in self.exrules:
+            vals = exrule._rule2update()
             res['exrules'].append(('create', vals))
         return res
 
-    def write(self, ids, values):
-        calendar_obj = Pool().get('calendar.calendar')
-        collection_obj = Pool().get('webdav.collection')
+    @classmethod
+    def write(cls, todos, values):
+        pool = Pool()
+        Calendar = pool.get('calendar.calendar')
+        Collection = pool.get('webdav.collection')
 
         cursor = Transaction().cursor
 
@@ -295,19 +296,17 @@
         if 'sequence' in values:
             del values['sequence']
 
-        res = super(Todo, self).write(ids, values)
+        super(Todo, cls).write(todos, values)
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
+        ids = [t.id for t in todos]
         for i in range(0, len(ids), cursor.IN_MAX):
             sub_ids = ids[i:i + cursor.IN_MAX]
             red_sql, red_ids = reduce_ids('id', sub_ids)
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET sequence = sequence + 1 ' \
                     'WHERE ' + red_sql, red_ids)
 
-        for todo in self.browse(ids):
+        for todo in todos:
             if todo.calendar.owner \
                     and (todo.organizer == todo.calendar.owner.email \
                     or (todo.parent \
@@ -322,57 +321,56 @@
                             and x.email != todo.parent.organizer]
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        todo_ids = self.search([
+                        todo2s = cls.search([
                             ('uuid', '=', todo.uuid),
                             ('calendar.owner.email', 'in', attendee_emails),
                             ('id', '!=', todo.id),
                             ('recurrence', '=', todo.recurrence),
                             ])
-                    for todo2 in self.browse(todo_ids):
+                    for todo2 in todo2s:
                         if todo2.calendar.owner.email in attendee_emails:
                             attendee_emails.remove(todo2.calendar.owner.email)
                     with Transaction().set_user(0):
-                        self.write(todo_ids, self._todo2update(todo))
+                        cls.write(todos, todo._todo2update())
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        calendar_ids = calendar_obj.search([
+                        calendars = Calendar.search([
                             ('owner.email', 'in', attendee_emails),
                             ])
                         if not todo.recurrence:
-                            for calendar_id in calendar_ids:
-                                new_id = self.copy(todo.id, default={
-                                    'calendar': calendar_id,
+                            for calendar in calendars:
+                                new_todo, = cls.copy([todo], default={
+                                    'calendar': calendar.id,
                                     'occurences': None,
                                     })
                                 for occurence in todo.occurences:
-                                    self.copy(occurence.id, default={
-                                        'calendar': calendar_id,
-                                        'parent': new_id,
+                                    cls.copy([occurence], default={
+                                        'calendar': calendar.id,
+                                        'parent': new_todo.id,
                                         })
                         else:
-                            parent_ids = self.search([
+                            parents = cls.search([
                                     ('uuid', '=', todo.uuid),
                                     ('calendar.owner.email', 'in',
                                         attendee_emails),
                                     ('id', '!=', todo.id),
                                     ('recurrence', '=', None),
                                     ])
-                            for parent in self.browse(parent_ids):
-                                self.copy(todo.id, default={
+                            for parent in parents:
+                                cls.copy([todo], default={
                                     'calendar': parent.calendar.id,
                                     'parent': parent.id,
                                     })
         # Restart the cache for todo
-        collection_obj.todo.reset()
-        return res
+        Collection._todo_cache.clear()
 
-    def delete(self, ids):
-        attendee_obj = Pool().get('calendar.todo.attendee')
-        collection_obj = Pool().get('webdav.collection')
+    @classmethod
+    def delete(cls, todos):
+        pool = Pool()
+        Attendee = pool.get('calendar.todo.attendee')
+        Collection = pool.get('webdav.collection')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        for todo in self.browse(ids):
+        for todo in todos:
             if todo.calendar.owner \
                     and (todo.organizer == todo.calendar.owner.email \
                     or (todo.parent \
@@ -385,13 +383,13 @@
                             if x.email != todo.parent.organizer]
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        todo_ids = self.search([
+                        todos_delete = cls.search([
                             ('uuid', '=', todo.uuid),
                             ('calendar.owner.email', 'in', attendee_emails),
                             ('id', '!=', todo.id),
                             ('recurrence', '=', todo.recurrence),
                             ])
-                        self.delete(todo_ids)
+                        cls.delete(todos_delete)
             elif todo.organizer \
                     or (todo.parent and todo.parent.organizer):
                 if todo.organizer:
@@ -399,62 +397,54 @@
                 else:
                     organizer = todo.parent.organizer
                 with Transaction().set_user(0):
-                    todo_ids = self.search([
+                    todo2s = cls.search([
                         ('uuid', '=', todo.uuid),
                         ('calendar.owner.email', '=', organizer),
                         ('id', '!=', todo.id),
                         ('recurrence', '=', todo.recurrence),
                         ], limit=1)
-                    if todo_ids:
-                        todo2 = self.browse(todo_ids[0])
+                    if todo2s:
+                        todo2, = todo2s
                         for attendee in todo2.attendees:
                             if attendee.email == todo.calendar.owner.email:
-                                attendee_obj.write(attendee.id, {
+                                Attendee.write([attendee], {
                                     'status': 'declined',
                                     })
-        res = super(Todo, self).delete(ids)
+        super(Todo, cls).delete(todos)
         # Restart the cache for todo
-        collection_obj.todo.reset()
-        return res
+        Collection._todo_cache.clear()
 
-    def copy(self, ids, default=None):
-        int_id = isinstance(ids, (int, long))
-        if int_id:
-            ids = [ids]
-
+    @classmethod
+    def copy(cls, todos, default=None):
         if default is None:
             default = {}
 
-        new_ids = []
-        for todo_id in ids:
+        new_todos = []
+        for todo in todos:
             current_default = default.copy()
-            current_default['uuid'] = self.default_uuid()
-            new_id = super(Todo, self).copy(todo_id, default=current_default)
-            new_ids.append(new_id)
+            current_default['uuid'] = cls.default_uuid()
+            new_todo, = super(Todo, cls).copy([todo], default=current_default)
+            new_todos.append(new_todo)
+        return new_todos
 
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-    def ical2values(self, todo_id, ical, calendar_id, vtodo=None):
+    @classmethod
+    def ical2values(cls, todo_id, ical, calendar_id, vtodo=None):
         '''
-        Convert iCalendar to values for create or write
-
-        :param todo_id: the todo id for write or None for create
-        :param ical: a ical instance of vobject
-        :param calendar_id: the calendar id of the todo
-        :param vtodo: the vtodo of the ical to use if None use the first one
-        :return: a dictionary with values
+        Convert iCalendar to values for create or write with:
+        todo_id: the todo id for write or None for create
+        ical: a ical instance of vobject
+        calendar_id: the calendar id of the todo
+        vtodo: the vtodo of the ical to use if None use the first one
         '''
         pool = Pool()
-        category_obj = pool.get('calendar.category')
-        location_obj = pool.get('calendar.location')
-        alarm_obj = pool.get('calendar.todo.alarm')
-        attendee_obj = pool.get('calendar.todo.attendee')
-        rdate_obj = pool.get('calendar.todo.rdate')
-        exdate_obj = pool.get('calendar.todo.exdate')
-        rrule_obj = pool.get('calendar.todo.rrule')
-        exrule_obj = pool.get('calendar.todo.exrule')
+        Category = pool.get('calendar.category')
+        Location = pool.get('calendar.location')
+        Alarm = pool.get('calendar.todo.alarm')
+        Attendee = pool.get('calendar.todo.attendee')
+        Rdate = pool.get('calendar.todo.rdate')
+        Exdate = pool.get('calendar.todo.exdate')
+        Rrule = pool.get('calendar.todo.rrule')
+        Exrule = pool.get('calendar.todo.exrule')
 
         vtodos = []
         if not vtodo:
@@ -467,7 +457,7 @@
 
         todo = None
         if todo_id:
-            todo = self.browse(todo_id)
+            todo = cls(todo_id)
         res = {}
         if not todo:
             if hasattr(vtodo, 'uid'):
@@ -535,40 +525,39 @@
         else:
             res['status'] = ''
         if hasattr(vtodo, 'categories'):
-            category_ids = category_obj.search([
+            categories = Category.search([
                 ('name', 'in', [x for x in vtodo.categories.value]),
                 ])
-            categories = category_obj.browse(category_ids)
             category_names2ids = {}
             for category in categories:
                 category_names2ids[category.name] = category.id
             for category in vtodo.categories.value:
                 if category not in category_names2ids:
-                    category_ids.append(category_obj.create({
+                    categories.append(Category.create({
                         'name': category,
                         }))
-            res['categories'] = [('set', category_ids)]
+            res['categories'] = [('set', [c.id for c in categories])]
         else:
             res['categories'] = [('unlink_all',)]
         if hasattr(vtodo, 'class'):
             if getattr(vtodo, 'class').value.lower() in \
-                    dict(self.classification.selection):
+                    dict(cls.classification.selection):
                 res['classification'] = getattr(vtodo, 'class').value.lower()
             else:
                 res['classification'] = 'public'
         else:
             res['classification'] = 'public'
         if hasattr(vtodo, 'location'):
-            location_ids = location_obj.search([
+            locations = Location.search([
                 ('name', '=', vtodo.location.value),
                 ], limit=1)
-            if not location_ids:
-                location_id = location_obj.create({
+            if not locations:
+                location, = Location.create({
                     'name': vtodo.location.value,
                     })
             else:
-                location_id = location_ids[0]
-            res['location'] = location_id
+                location, = locations
+            res['location'] = location.id
         else:
             res['location'] = None
 
@@ -590,7 +579,7 @@
         if hasattr(vtodo, 'attendee'):
             while vtodo.attendee_list:
                 attendee = vtodo.attendee_list.pop()
-                vals = attendee_obj.attendee2values(attendee)
+                vals = Attendee.attendee2values(attendee)
                 if vals['email'] in attendees_todel:
                     res['attendees'].append(('write',
                         attendees_todel[vals['email']], vals))
@@ -606,7 +595,7 @@
             while vtodo.rdate_list:
                 rdate = vtodo.rdate_list.pop()
                 for date in rdate.value:
-                    vals = rdate_obj.date2values(date)
+                    vals = Rdate.date2values(date)
                     res['rdates'].append(('create', vals))
 
         res['exdates'] = []
@@ -616,7 +605,7 @@
             while vtodo.exdate_list:
                 exdate = vtodo.exdate_list.pop()
                 for date in exdate.value:
-                    vals = exdate_obj.date2values(date)
+                    vals = Exdate.date2values(date)
                     res['exdates'].append(('create', vals))
 
         res['rrules'] = []
@@ -625,7 +614,7 @@
         if hasattr(vtodo, 'rrule'):
             while vtodo.rrule_list:
                 rrule = vtodo.rrule_list.pop()
-                vals = rrule_obj.rule2values(rrule)
+                vals = Rrule.rule2values(rrule)
                 res['rrules'].append(('create', vals))
 
         res['exrules'] = []
@@ -634,7 +623,7 @@
         if hasattr(vtodo, 'exrule'):
             while vtodo.exrule_list:
                 exrule = vtodo.exrule_list.pop()
-                vals = exrule_obj.rule2values(exrule)
+                vals = Exrule.rule2values(exrule)
                 res['exrules'].append(('create', vals))
 
         if todo:
@@ -644,7 +633,7 @@
             res.setdefault('alarms', [])
             while vtodo.valarm_list:
                 valarm = vtodo.valarm_list.pop()
-                vals = alarm_obj.valarm2values(valarm)
+                vals = Alarm.valarm2values(valarm)
                 res['alarms'].append(('create', vals))
 
         if hasattr(ical, 'vtimezone'):
@@ -668,7 +657,7 @@
                             == vtodo.recurrence_id.value:
                         todo_id = occurence.id
                         occurences_todel.remove(occurence.id)
-            vals = self.ical2values(todo_id, ical, calendar_id, vtodo=vtodo)
+            vals = cls.ical2values(todo_id, ical, calendar_id, vtodo=vtodo)
             if todo:
                 vals['uuid'] = todo.uuid
             else:
@@ -683,29 +672,16 @@
             res['occurences'].append(('delete', occurences_todel))
         return res
 
-    def todo2ical(self, todo):
+    def todo2ical(self):
         '''
         Return an iCalendar instance of vobject for todo
-
-        :param todo: a BrowseRecord of calendar.todo
-            or a calendar.todo id
-        :return: an iCalendar instance of vobject
         '''
         pool = Pool()
-        user_obj = pool.get('res.user')
-        alarm_obj = pool.get('calendar.todo.alarm')
-        attendee_obj = pool.get('calendar.todo.attendee')
-        rdate_obj = pool.get('calendar.todo.rdate')
-        exdate_obj = pool.get('calendar.todo.exdate')
-        rrule_obj = pool.get('calendar.todo.rrule')
-        exrule_obj = pool.get('calendar.todo.exrule')
+        User = pool.get('res.user')
 
-        if isinstance(todo, (int, long)):
-            todo = self.browse(todo)
-
-        user = user_obj.browse(Transaction().user)
-        if todo.timezone:
-            tztodo = dateutil.tz.gettz(todo.timezone)
+        user = User(Transaction().user)
+        if self.timezone:
+            tztodo = dateutil.tz.gettz(self.timezone)
         elif user.timezone:
             tztodo = dateutil.tz.gettz(user.timezone)
         else:
